searchNodes=[{"doc":"This module contains macroses to be used by user Any macro here belongs to one of two categories: 1) Macro which creates path closure (sigil_P/2, path/2, ~&gt;/2) 2) Macro which uses path closure as path (over/3, set/3, view/2) Path closure is a closure which takes two arguments: 1) Atom.t() with operaion name 2) Tuple.t() of arguments of this operation","ref":"Pathex.html","title":"Pathex","type":"module"},{"doc":"Macro of three arguments which sets the given value in the given path of given structure If the path does not exist it creates the path favouring maps when structure is unknown Example: iex&gt; require Pathex; import Pathex iex&gt; x = 1 iex&gt; {:ok, [0, %{x: 123}]} = force_set x / :x, [0, %{x: 8}], 123 iex&gt; p = path &quot;hey&quot; / 0 iex&gt; {:ok, %{&quot;hey&quot; =&gt; %{0 =&gt; 1}}} = force_set p, %{}, 1","ref":"Pathex.html#force_set/3","title":"Pathex.force_set/3","type":"macro"},{"doc":"Macro of three arguments which applies given function for item in the given path of given structure Example: iex&gt; require Pathex; import Pathex iex&gt; x = 1 iex&gt; inc = fn x -&gt; x + 1 end iex&gt; {:ok, [0, %{x: 9}]} = over x / :x, [0, %{x: 8}], inc iex&gt; p = path &quot;hey&quot; / 0 iex&gt; {:ok, %{&quot;hey&quot; =&gt; [2, [2]]}} = over p, %{&quot;hey&quot; =&gt; [1, [2]]}, inc","ref":"Pathex.html#over/3","title":"Pathex.over/3","type":"macro"},{"doc":"Creates path for given structure Example: iex&gt; require Pathex; import Pathex iex&gt; x = 1 iex&gt; mypath = path 1 / :atom / &quot;string&quot; / {&quot;tuple?&quot;} / x iex&gt; structure = [0, [atom: %{&quot;string&quot; =&gt; %{{&quot;tuple?&quot;} =&gt; %{1 =&gt; 2}}}]] iex&gt; {:ok, 2} = view mypath, structure","ref":"Pathex.html#path/2","title":"Pathex.path/2","type":"macro"},{"doc":"Macro of three arguments which sets the given value in the given path of given structure Example: iex&gt; require Pathex; import Pathex iex&gt; x = 1 iex&gt; {:ok, [0, %{x: 123}]} = set x / :x, [0, %{x: 8}], 123 iex&gt; p = path &quot;hey&quot; / 0 iex&gt; {:ok, %{&quot;hey&quot; =&gt; [123, [2]]}} = set p, %{&quot;hey&quot; =&gt; [1, [2]]}, 123","ref":"Pathex.html#set/3","title":"Pathex.set/3","type":"macro"},{"doc":"Sigil for paths. Has only two modes: naive (default) and json. Naive paths should look like ~P[&quot;string&quot;/:atom/1] Json paths should look like ~P[string/this_one_is_too/1/0]","ref":"Pathex.html#sigil_P/2","title":"Pathex.sigil_P/2","type":"macro"},{"doc":"Macro gets the value in the given path of the given structure Example: iex&gt; require Pathex; import Pathex iex&gt; x = 1 iex&gt; {:ok, 8} = view x / :x, [0, %{x: 8}] iex&gt; p = path &quot;hey&quot; / 0 iex&gt; {:ok, 9} = view p, %{&quot;hey&quot; =&gt; {9, -9}}","ref":"Pathex.html#view/2","title":"Pathex.view/2","type":"macro"},{"doc":"Creates composition of two paths Example: iex&gt; require Pathex; import Pathex iex&gt; p1 = path :x / :y iex&gt; p2 = path :a / :b iex&gt; composed_path = p1 ~&gt; p2 iex&gt; {:ok, 1} = view composed_path, %{x: [y: [a: [a: 0, b: 1]]]}","ref":"Pathex.html#~%3E/2","title":"Pathex.~>/2","type":"macro"},{"doc":"","ref":"Pathex.html#t:el_structure/0","title":"Pathex.el_structure/0","type":"type"},{"doc":"","ref":"Pathex.html#t:key_type/0","title":"Pathex.key_type/0","type":"type"},{"doc":"","ref":"Pathex.html#t:mod/0","title":"Pathex.mod/0","type":"type"},{"doc":"","ref":"Pathex.html#t:path/0","title":"Pathex.path/0","type":"type"},{"doc":"","ref":"Pathex.html#t:result/0","title":"Pathex.result/0","type":"type"},{"doc":"","ref":"Pathex.html#t:struct_type/0","title":"Pathex.struct_type/0","type":"type"},{"doc":"","ref":"Pathex.html#t:t/0","title":"Pathex.t/0","type":"type"},{"doc":"Module for building combinations into path-closures","ref":"Pathex.Builder.html","title":"Pathex.Builder","type":"module"},{"doc":"This function creates quoted fn-closure from passed combination and operations Closure has two arguments: operation name and tuple or actual arguments It will look like iex&gt; fn :get, {struct} -&gt; ... :set, {struct, value} -&gt; ... ... end","ref":"Pathex.Builder.html#build/2","title":"Pathex.Builder.build/2","type":"function"},{"doc":"This function creates quoted fn-closure from passed combination and builder Closure has as much arguments as specified builder creates","ref":"Pathex.Builder.html#build_only/2","title":"Pathex.Builder.build_only/2","type":"function"},{"doc":"","ref":"Pathex.Builder.html#t:t/0","title":"Pathex.Builder.t/0","type":"type"},{"doc":"Structure for working with closures as ASTs Fields vars - list of variables/arguments code - body of a closure","ref":"Pathex.Builder.Code.html","title":"Pathex.Builder.Code","type":"module"},{"doc":"","ref":"Pathex.Builder.Code.html#multiple_to_fn/1","title":"Pathex.Builder.Code.multiple_to_fn/1","type":"function"},{"doc":"","ref":"Pathex.Builder.Code.html#new_one_arg_pipe/1","title":"Pathex.Builder.Code.new_one_arg_pipe/1","type":"function"},{"doc":"","ref":"Pathex.Builder.Code.html#to_def/2","title":"Pathex.Builder.Code.to_def/2","type":"function"},{"doc":"","ref":"Pathex.Builder.Code.html#to_fn/1","title":"Pathex.Builder.Code.to_fn/1","type":"function"},{"doc":"","ref":"Pathex.Builder.Code.html#t:code_type/0","title":"Pathex.Builder.Code.code_type/0","type":"type"},{"doc":"","ref":"Pathex.Builder.Code.html#t:t/0","title":"Pathex.Builder.Code.t/0","type":"type"},{"doc":"Setter which creates given path if item in path does not exist","ref":"Pathex.Builder.ForceSetter.html","title":"Pathex.Builder.ForceSetter","type":"module"},{"doc":"Callback implementation for Pathex.Builder.Setter.build/1.","ref":"Pathex.Builder.ForceSetter.html#build/1","title":"Pathex.Builder.ForceSetter.build/1","type":"function"},{"doc":"Selector which matches with one big case in case","ref":"Pathex.Builder.MatchableSelector.html","title":"Pathex.Builder.MatchableSelector","type":"module"},{"doc":"Callback implementation for Pathex.Builder.Selector.build/1.","ref":"Pathex.Builder.MatchableSelector.html#build/1","title":"Pathex.Builder.MatchableSelector.build/1","type":"function"},{"doc":"WIP Selector which tries to use one big case when possible","ref":"Pathex.Builder.OptimizedSelector.html","title":"Pathex.Builder.OptimizedSelector","type":"module"},{"doc":"Callback implementation for Pathex.Builder.Selector.build/1.","ref":"Pathex.Builder.OptimizedSelector.html#build/1","title":"Pathex.Builder.OptimizedSelector.build/1","type":"function"},{"doc":"","ref":"Pathex.Builder.OptimizedSelector.html#build_from_tree/1","title":"Pathex.Builder.OptimizedSelector.build_from_tree/1","type":"function"},{"doc":"Creates tree like tree_item = { [matchable_paths], [] }","ref":"Pathex.Builder.OptimizedSelector.html#to_tree/1","title":"Pathex.Builder.OptimizedSelector.to_tree/1","type":"function"},{"doc":"","ref":"Pathex.Builder.OptimizedSelector.html#t:item/0","title":"Pathex.Builder.OptimizedSelector.item/0","type":"type"},{"doc":"","ref":"Pathex.Builder.OptimizedSelector.html#t:path/0","title":"Pathex.Builder.OptimizedSelector.path/0","type":"type"},{"doc":"","ref":"Pathex.Builder.OptimizedSelector.html#t:tree/0","title":"Pathex.Builder.OptimizedSelector.tree/0","type":"type"},{"doc":"Module with common functions for selectors","ref":"Pathex.Builder.Selector.html","title":"Pathex.Builder.Selector","type":"behaviour"},{"doc":"","ref":"Pathex.Builder.Selector.html#c:build/1","title":"Pathex.Builder.Selector.build/1","type":"callback"},{"doc":"","ref":"Pathex.Builder.Selector.html#create_getter/2","title":"Pathex.Builder.Selector.create_getter/2","type":"function"},{"doc":"","ref":"Pathex.Builder.Selector.html#fallback/0","title":"Pathex.Builder.Selector.fallback/0","type":"function"},{"doc":"","ref":"Pathex.Builder.Selector.html#match_from_path/2","title":"Pathex.Builder.Selector.match_from_path/2","type":"function"},{"doc":"Module with common functions for setters","ref":"Pathex.Builder.Setter.html","title":"Pathex.Builder.Setter","type":"behaviour"},{"doc":"","ref":"Pathex.Builder.Setter.html#c:build/1","title":"Pathex.Builder.Setter.build/1","type":"callback"},{"doc":"","ref":"Pathex.Builder.Setter.html#create_setter/2","title":"Pathex.Builder.Setter.create_setter/2","type":"function"},{"doc":"","ref":"Pathex.Builder.Setter.html#fallback/0","title":"Pathex.Builder.Setter.fallback/0","type":"function"},{"doc":"","ref":"Pathex.Builder.Setter.html#wrap_to_code/3","title":"Pathex.Builder.Setter.wrap_to_code/3","type":"function"},{"doc":"Simple selector","ref":"Pathex.Builder.SimpleSelector.html","title":"Pathex.Builder.SimpleSelector","type":"module"},{"doc":"Callback implementation for Pathex.Builder.Selector.build/1.","ref":"Pathex.Builder.SimpleSelector.html#build/1","title":"Pathex.Builder.SimpleSelector.build/1","type":"function"},{"doc":"Setter which simply sets new value in given path","ref":"Pathex.Builder.SimpleSetter.html","title":"Pathex.Builder.SimpleSetter","type":"module"},{"doc":"Callback implementation for Pathex.Builder.Setter.build/1.","ref":"Pathex.Builder.SimpleSetter.html#build/1","title":"Pathex.Builder.SimpleSetter.build/1","type":"function"},{"doc":"Setter which simply updates value in the given path","ref":"Pathex.Builder.UpdateSetter.html","title":"Pathex.Builder.UpdateSetter","type":"module"},{"doc":"Callback implementation for Pathex.Builder.Setter.build/1.","ref":"Pathex.Builder.UpdateSetter.html#build/1","title":"Pathex.Builder.UpdateSetter.build/1","type":"function"},{"doc":"Module for combination structures","ref":"Pathex.Combination.html","title":"Pathex.Combination","type":"module"},{"doc":"","ref":"Pathex.Combination.html#from_path/1","title":"Pathex.Combination.from_path/1","type":"function"},{"doc":"","ref":"Pathex.Combination.html#to_paths/1","title":"Pathex.Combination.to_paths/1","type":"function"},{"doc":"","ref":"Pathex.Combination.html#t:t/0","title":"Pathex.Combination.t/0","type":"type"},{"doc":"Util functions for working with AST","ref":"Pathex.Common.html","title":"Pathex.Common","type":"module"},{"doc":"","ref":"Pathex.Common.html#detect_variables/2","title":"Pathex.Common.detect_variables/2","type":"function"},{"doc":"","ref":"Pathex.Common.html#list_match/2","title":"Pathex.Common.list_match/2","type":"function"},{"doc":"","ref":"Pathex.Common.html#pin/1","title":"Pathex.Common.pin/1","type":"function"},{"doc":"","ref":"Pathex.Common.html#update_variables/3","title":"Pathex.Common.update_variables/3","type":"function"},{"doc":"Module for working with modificators for paths Like :naive, :json, :map","ref":"Pathex.Operations.html","title":"Pathex.Operations","type":"module"},{"doc":"","ref":"Pathex.Operations.html#from_mod/1","title":"Pathex.Operations.from_mod/1","type":"function"},{"doc":"","ref":"Pathex.Operations.html#t:name/0","title":"Pathex.Operations.name/0","type":"type"},{"doc":"","ref":"Pathex.Operations.html#t:t/0","title":"Pathex.Operations.t/0","type":"type"},{"doc":"Module for parsing path created wuth sigils","ref":"Pathex.Parser.html","title":"Pathex.Parser","type":"module"},{"doc":"","ref":"Pathex.Parser.html#parse/2","title":"Pathex.Parser.parse/2","type":"function"},{"doc":"","ref":"Pathex.Parser.html#t:suggested_path/0","title":"Pathex.Parser.suggested_path/0","type":"type"},{"doc":"Utils module for parsing paths created with Pathex.path/2","ref":"Pathex.QuotedParser.html","title":"Pathex.QuotedParser","type":"module"},{"doc":"","ref":"Pathex.QuotedParser.html#parse/3","title":"Pathex.QuotedParser.parse/3","type":"function"}]